module Tuya
	class Command
		class Group < Command
			class GroupCreate < Group
				self.abstract_command = false
				self.summary = "create a remote repo spec(if need) & init your local repo spec"
				self.command = 'create'

				def run
					puts "group name is #{@name}".green

					group = Tuya::ConfigGroup.new(@name)
					Tuya::TYGroup.setup_spec group
					Tuya::TYGroup.create_tuya_public_inc_if_need
				end

				def self.options
					[
						['--name=group_name', '--name the name for your group']
					]
				end

				def initialize(argv)
					super
					@name = argv.option('name')
				end

				def validate!
					help! "name need" unless @name
				end
			end
		end
	end
end