module Tuya
	class Command
		class Lib < Command
			class CreateSimple < Lib
				self.abstract_command = false
				self.summary = "create a module"
				self.command = 'create-simple'

				def self.options
					[
						['--name=module_name', '--name to named your module']
					].concat(super)
				end

				def validate!
					help! "name need" unless @name
				end

				def initialize(argv)
					super
					@name = argv.option('name')
				end

				def run

					puts "do create a simple module named: #{@name}".green

					progressbar = ProgressBar.create
					15.times { progressbar.increment; sleep 2 }

					t_c = Thread.new {createModule()}

					t_c.join
					progressbar.finish

					puts "end create simple module: #{@name}".green
				end

				def createModule
					result = `pod lib create #{@name} --template-url=https://code.registry.wgine.com/client-platform/pod-template-simple.git`
					result.each_line do |s|
						if s.include?("fatal")
							puts "#{s}".red
						end
					end
				end
			end
		end
	end
end