module Tuya
	class Command
		class Repo < Command
			class Push < Repo
				self.abstract_command = false
				self.summary = "push a module to tuya specs(your spec)"
				self.command = 'push'

				def validate!

					@podspec = Tuya::PodSpec.ask_pod_spec unless  @podspec
					help! "\npodspec can not be nil" unless  @podspec

					@version = Tuya::PodSpec.pod_spec_version @podspec unless  @version
					help! "\nuse --version assign your verion " unless @version
				end

				def initialize(argv)
					super

					@is_commit = argv.flag?('commit', true)

					@version = argv.option('version')
					@podspec = argv.shift_argument

				end

				def run
					puts "Pushing the podspec: #{@podspec} to version: #{@version}".green

					Tuya::SpecRepo.push(@version, @is_commit, @podspec, @verbose)
				end
			end
		end
	end
end