module Tuya

	TUYA_ODM_GITLAB_HOST = 'https://code-odm.tuya-inc.com'
	TUYA_ODM_PUBLIC_REPO = 'TYPublicSpecs'
	TUYA_ODM_PUBLIC_REPO_GIT = 'https://github.com/TuyaInc/TYPublicSpecs.git'

	# require 'singleton'
	class Config

		# include Singleton

		CONFIG_NAME = 'tuya-cli-public.json'


		def self.config_path(user)
			"#{user}/.tuya/"
		end

		def self.config_file_path(user)
			path = config_path user
			file = CONFIG_NAME
			"#{path}#{file}"
		end

		def self.local_config(user)
			path = config_path user
			file = CONFIG_NAME
			file_path = config_file_path user

			if File.exist? file_path
				config_string = File.read(file_path)

				require 'json'
				content = JSON.parse(config_string)

				Tuya::ConfigGroup.new content['group']
			end
		end

		attr_accessor :path
		attr_accessor :file
		attr_accessor :file_path
		attr_accessor :group_name


		def initialize(group_name)

			@group_name = group_name
			@system = Tuya::System.instance

			@path = Tuya::Config.config_path @system.user
			@file = CONFIG_NAME
			@file_path = Tuya::Config.config_file_path @system.user

		end

		# create local file
		def update_local_config

			require 'json'

			`mkdir -p #{@path}`

			group_hash = Hash["group"=>@group_name]
			group_json = JSON group_hash

			if File.exist?@file_path
				`rm #{file_path}`
			end

			fh = File.new(@file_path, 'w')
			fh.puts group_json
			fh.close

		end

		def group_local

		end

	end

	class ConfigGroup
		attr_accessor :name
		attr_accessor :spec
		attr_accessor :url
		def initialize(name)
			@name = name

			@spec = "#{name}Specs"
			@url = "#{Tuya::TUYA_ODM_GITLAB_HOST}/#{name}/#{@spec}.git"
		end
	end

	class ConfigLib
		attr_accessor :name
		attr_accessor :group_name
		attr_accessor :url
		def initialize(group_name, name)
			@name = name
			@group_name = group_name
			@url = "#{Tuya::TUYA_ODM_GITLAB_HOST}/#{group_name}/#{name}.git"
		end
	end
end